struct TMacro
{
	int		FARKey;
	bool	atStartup;
	bool	submenu;
	char	Name[MAX_REG_LEN];
	char	Word[MAX_REG_LEN], At[MAX_REG_LEN], MacroText[MAX_STR_LEN];
	char	before[MAX_REG_LEN], after[MAX_REG_LEN], immChar;
};

static void InitMacro ()
{
	reloadInProcess = true;

	HANDLE			hScreen = Info.SaveScreen (0, 0, -1, -1);
	const char	*MsgItems[] = { GetMsg (MTitle), GetMsg (MLoading) };
	Info.Message (Info.ModuleNumber, 0, NULL, MsgItems, dimOf (MsgItems), 0);

	char	path[NM];
	addExt (lstrcpy (path, Info.ModuleName), ".xml");

	char	*file = lstrrchr (path, '\\');
	*(file++) = 0;

	char	*fileBuff = getFile (path, file);
	if (fileBuff)
	{
		char				*item, *p = fileBuff;
		char				name[MAX_STR_LEN], value[MAX_STR_LEN];
		TLang				*lng = NULL;
		bool				group;
		TCollection dummyLang;
		memcpy (&langColl, &dummyLang, sizeof (TLangCollection));
		findSectionInXML (p);
		while ((item = getItem (p, name, group)) != NULL)
		{
			if (group && !FSF.LStricmp (name, "/True-Tpl"))
				findSectionInXML (p);
			else if (!group && !FSF.LStricmp (name, "Include"))
			{
				char	incFile[NM];
				*incFile = 0;

				TCollection *dc = (lng == NULL) ? NULL : &(lng->defineColl);
				while (parseItem (dc, item, name, value))
					if (!FSF.LStricmp (name, "File")) lstrcpy (incFile, value);
				if (*incFile)
				{
					char	*incBuff = getFile (path, incFile);
					if (incBuff)
					{
						char	*newBuff = new char[lstrlen (incBuff) + lstrlen (p) + 16];
						if (newBuff)
						{
							lstrcat (lstrcat (lstrcpy (newBuff, incBuff), "\n<TrueTpl>\n"), p);
							delete[] fileBuff;
							fileBuff = p = newBuff;
							findSectionInXML (p);
						}

						delete[] incBuff;
					}
				}
			}
			else if (group && !FSF.LStricmp (name, "/Language"))
				lng = NULL;
			else if (group && !FSF.LStricmp (name, "Language"))
			{
				lng = new TLang;
				lng->ignoreCase = false;
				lng->setCP = lng->mask[0] = lng->desc[0] = lng->imm[0] = lng->immExp[0] = 0;
				lng->defExec.defaults ();
				while (parseItem (&(lng->defineColl), item, name, value))
				{
					if (!FSF.LStricmp (name, "File"))
						lstrcpy (lng->mask, value);
					else if (!FSF.LStricmp (name, "Desc"))
						lstrcpy (lng->desc, value);
					else if (!FSF.LStricmp (name, "BlockComment"))
						lstrcpy (lng->blockcomment, value);
					else if (!FSF.LStricmp (name, "CP"))
						lng->setCP = FSF.atoi (value);
					else if (!FSF.LStricmp (name, "IgnoreCase"))
						lng->ignoreCase = FSF.atoi (value) ? true : false;
					else
						parseExec (&(lng->defExec), name, value);
				}

				if (lng->mask[0])
					langColl.insert (lng);
				else
				{
					delete lng;
					lng = NULL;
				}
			}
			else if (lng != NULL)
			{
				if (!group && !FSF.LStricmp (name, "Define"))
				{
					TDefine *tmpd = new TDefine ("", "");
					while (parseItem (&(lng->defineColl), item, name, value))
					{
						if (!FSF.LStricmp (name, "Name"))
							lstrcpy (tmpd->name, value);
						else if (!FSF.LStricmp (name, "Value"))
							lstrcpy (tmpd->value, value);
					}

					if (tmpd->name[0])
						lng->defineColl.insert (tmpd);
					else
						delete tmpd;
				}
				else if (!group && !FSF.LStricmp (name, "Navigation"))
				{
					TNavy *tmpn = new TNavy;
					while (parseItem (&(lng->defineColl), item, name, value))
					{
						if (!FSF.LStricmp (name, "Mask"))
							lstrcpy (tmpn->mask, value);
						else if (!FSF.LStricmp (name, "Pos"))
							tmpn->pos = FSF.atoi (value);
						else if (!FSF.LStricmp (name, "Path"))
							FSF.ExpandEnvironmentStr (value, tmpn->path, MAX_STR_LEN);
						else if (!FSF.LStricmp (name, "Suffixes"))
							FSF.ExpandEnvironmentStr (value, tmpn->suffixes, MAX_STR_LEN);
						else if (!FSF.LStricmp (name, "Rect"))
							FSF.sscanf
								(
									value,
									"%d%%,%d%%,%d%%,%d%%",
									&tmpn->rect[0],
									&tmpn->rect[1],
									&tmpn->rect[2],
									&tmpn->rect[3]
								);
						else if (!FSF.LStricmp (name, "Viewer"))
							tmpn->viewer = FSF.atoi (value) ? true : false;
					}

					if (tmpn->mask[0])
						lng->navyColl.insert (tmpn);
					else
						delete tmpn;
				}
				else if (!group && !FSF.LStricmp (name, "Format"))
				{
					TFormat *tmpf = new TFormat;
					while (parseItem (&(lng->defineColl), item, name, value))
					{
						if (!FSF.LStricmp (name, "Name"))
							lstrcpy (tmpf->name, value);
						else if (!FSF.LStricmp (name, "Command"))
							FSF.ExpandEnvironmentStr (value, tmpf->comm, MAX_STR_LEN);
						else if (!FSF.LStricmp (name, "Echo"))
							tmpf->echo = FSF.atoi (value) ? true : false;
					}

					if (tmpf->name[0] && tmpf->comm[0])
						lng->formatColl.insert (tmpf);
					else
						delete tmpf;
				}
				else if (!group && !FSF.LStricmp (name, "Expand"))
				{
					TMacro	*tmpm = new TMacro;
					lstrcpy (tmpm->At, expOnBlank);
					tmpm->immChar = 0;
					tmpm->Name[0] = tmpm->Word[0] = tmpm->before[0] = tmpm->after[0] = tmpm->MacroText[0] = 0;
					tmpm->FARKey = -1;
					tmpm->atStartup = false;
					tmpm->submenu = false;

					int validTag = false;
					while (parseItem (&(lng->defineColl), item, name, value))
					{
						if (!FSF.LStricmp (name, "Pattern"))
						{
							lstrcpy (tmpm->Word, value);
							if (tmpm->Word[0])
							{
								validTag = true;

								char	*opDelimiter = lstrchr (tmpm->Word, '|');
								if (opDelimiter)
								{
									char	rest[MAX_STR_LEN], cc[3] = "(.";
									*opDelimiter = 0;
									lstrcpy (rest, opDelimiter + 1);
									for (char *p = rest; *p; p++)
									{
										cc[1] = *p;
										lstrcat (tmpm->Word, cc);
									}
									{
										for (char *p = rest; *p; p++) lstrcat (tmpm->Word, ")?");
									}
								}
							}
						}
						else if (!FSF.LStricmp (name, "To"))
							lstrcpy (tmpm->MacroText, value);
						else if (!FSF.LStricmp (name, "Key"))
						{
							validTag = true;
							tmpm->FARKey = FSF.FarNameToKey (value);
						}
						else if (!FSF.LStricmp (name, "Imm"))
							tmpm->immChar = *value;
						else if (!FSF.LStricmp (name, "Init"))
						{
							validTag = true;
							tmpm->atStartup = FSF.atoi (value) ? true : false;
						}
						else if (!FSF.LStricmp (name, "At"))
						{
							if (!FSF.LStricmp (value, "AnyWhere"))
								lstrcpy (tmpm->At, expAnyWhere);
							else if (!FSF.LStricmp (value, "Start"))
								lstrcpy (tmpm->At, expAtStart);
							else if (!FSF.LStricmp (value, "Middle"))
								lstrcpy (tmpm->At, expAtMiddle);
							else if (!FSF.LStricmp (value, "End"))
								lstrcpy (tmpm->At, expAtEnd);
							else if (!FSF.LStricmp (value, "Blank"))
								lstrcpy (tmpm->At, expOnBlank);
							else
								lstrcpy (tmpm->At, value);
						}
						else if (!FSF.LStricmp (name, "Name"))
						{
							validTag = true;
							lstrcpy (tmpm->Name, value);
						}
						else if (!FSF.LStricmp (name, "SubMenu"))
						{
							tmpm->submenu = ((value[0] != '\0')) && ((value[0] == '1') && (value[1] == '\0'));
						}
					}

					if (validTag)
					{
						if (tmpm->At[0])
						{
							char	*opDelimiter = lstrstr (tmpm->At, "\\p");
							if (opDelimiter)
							{
								*opDelimiter = 0;
								lstrcpy (tmpm->before, tmpm->At);
								lstrcpy (tmpm->after, opDelimiter + 2);
							}
						}

						if (tmpm->immChar)
						{
							if (!lstrchr (lng->immExp, tmpm->immChar))
							{
								int len = lstrlen (lng->immExp);
								lng->immExp[len++] = tmpm->immChar;
								lng->immExp[len] = 0;
							}
						}

						lng->macroColl.insert (tmpm);
					}
					else
						delete tmpm;
				}
				else if (!group && !FSF.LStricmp (name, "Comment"))
				{
					TComment	*tmpc = new TComment;
					tmpc->mask[0] = 0;
					while (parseItem (&(lng->defineColl), item, name, value))
						if (!FSF.LStricmp (name, "Pattern")) lstrcpy (tmpc->mask, value);
					if (tmpc->mask[0])
						lng->commentColl.insert (tmpc);
					else
						delete tmpc;
				}
				else if (!group && !FSF.LStricmp (name, "Exec"))
				{
					TExec *tmpe = new TExec (lng->defExec);
					while (parseItem (&(lng->defineColl), item, name, value))
						if (!FSF.LStricmp (name, "Command"))
							lstrcpy (tmpe->cmd, value);
						else
							parseExec (tmpe, name, value);
					if (!tmpe->title[0]) lstrcpy (tmpe->title, tmpe->cmd);
					if (!tmpe->title[0]) tmpe->cmd[0] = 0;
					lng->execColl.insert (tmpe);
				}
				else if (!group && !FSF.LStricmp (name, "Compiler"))
				{
					TCompiler *tmpc = new TCompiler ();
					while (parseItem (&(lng->defineColl), item, name, value))
						if (!FSF.LStricmp (name, "Name"))
							lstrcpy (tmpc->title, value);
						else
							parseCompiler (tmpc, name, value);
					if (tmpc->title[0])
						lng->compilerColl.insert (tmpc);
					else
						delete tmpc;
				}
				else if (!group && !FSF.LStricmp (name, "Indent"))
				{
					TIndent *tmpi = new TIndent;
					tmpi->mask[0] = tmpi->relative[0] = 0;
					tmpi->BracketsMode = tmpi->start = tmpi->immChar = 0;
					for (int i = 0; i < 2; i++) tmpi->indent[i] = 0xFFFF;
					while (parseItem (&(lng->defineColl), item, name, value))
					{
						if (!FSF.LStricmp (name, "Pattern"))
							lstrcpy (tmpi->mask, value);
						else if (!FSF.LStricmp (name, "Line"))
							tmpi->indent[0] = FSF.atoi (value);
						else if (!FSF.LStricmp (name, "Next"))
							tmpi->indent[1] = FSF.atoi (value);
						else if (!FSF.LStricmp (name, "Imm"))
							tmpi->immChar = *value;
						else if (!FSF.LStricmp (name, "Start"))
							tmpi->start = FSF.atoi (value);
						else if (!FSF.LStricmp (name, "Relative"))
							lstrcpy (tmpi->relative, value);
					}

					if (tmpi->mask[0])
					{
						if (tmpi->immChar)
						{
							if (!lstrchr (lng->imm, tmpi->immChar))
							{
								int len = lstrlen (lng->imm);
								lng->imm[len++] = tmpi->immChar;
								lng->imm[len] = 0;
							}
						}

						lng->indentColl.insert (tmpi);
					}
					else
						delete tmpi;
				}
				else if (!group && !FSF.LStricmp (name, "Bracket"))
				{
					TBracket	*tmpb = new TBracket;
					TIndent		*tmp0 = new TIndent;
					TIndent		*tmp1 = new TIndent;
					tmpb->open[0] = tmpb->close[0] = 0;
					tmp0->relative[0] = 0;
					tmp0->start = tmp0->immChar = 0;
					tmp0->BracketsMode = 0;
					tmp1->relative[0] = 0;
					tmp1->start = tmp1->immChar = 0;
					tmp1->BracketsMode = 1;
					tmp1->bracketLink = lng->bracketColl.getCount ();
					tmp0->indent[0] = 0xFFFF;
					tmp0->indent[1] = 1;
					tmp1->indent[0] = 0;
					tmp1->indent[1] = 0xFFFF;
					while (parseItem (&(lng->defineColl), item, name, value))
					{
						if (!FSF.LStricmp (name, "Pattern"))
							lstrcpy (tmp0->mask, lstrcpy (tmpb->open, value));
						else if (!FSF.LStricmp (name, "Match"))
							lstrcpy (tmp1->mask, lstrcpy (tmpb->close, value));
						else if (!FSF.LStricmp (name, "Line"))
							tmp0->indent[0] = FSF.atoi (value);
						else if (!FSF.LStricmp (name, "Shift"))
							tmp0->indent[1] = FSF.atoi (value);
						else if (!FSF.LStricmp (name, "Next"))
							tmp1->indent[1] = FSF.atoi (value);
						else if (!FSF.LStricmp (name, "ImmOpen"))
							tmp0->immChar = *value;
						else if (!FSF.LStricmp (name, "ImmClose"))
							tmp1->immChar = *value;
						else if (!FSF.LStricmp (name, "Start"))
							tmp0->start = FSF.atoi (value);
					}

					if (tmpb->open[0] && tmpb->close[0])
					{
						if (tmp0->immChar)
						{
							if (!lstrchr (lng->imm, tmp0->immChar))
							{
								int len = lstrlen (lng->imm);
								lng->imm[len++] = tmp0->immChar;
								lng->imm[len] = 0;
							}
						}

						if (tmp1->immChar)
						{
							if (!lstrchr (lng->imm, tmp1->immChar))
							{
								int len = lstrlen (lng->imm);
								lng->imm[len++] = tmp1->immChar;
								lng->imm[len] = 0;
							}
						}

						lng->bracketColl.insert (tmpb);
						lng->indentColl.insert (tmp0);
						lng->indentColl.insert (tmp1);
					}
					else
					{
						delete tmpb;
						delete tmp0;
						delete tmp1;
					}
				}
			}
		}

		delete[] fileBuff;
	}

	Info.RestoreScreen (hScreen);
	reloadInProcess = reloadNeeded = false;
	doneThread ();
	initThread ();
}

static void DoneMacro ()
{
	langColl.removeAll ();
	doneThread ();
}

static TMacro *FindMacro
(
	TLang *lng,
	char	*before,
	char	*after,
	char	expChar,
	int		*delCount,
	int		bounds[][2],
	bool	frommenu = false
)
{
	unsigned	i;
	char			*regEnd = lng->ignoreCase ? "\\s*$/i" : "\\s*$/";
	for (i = 0; i < lng->macroColl.getCount (); i++)
	{
		TMacro	*mm = (TMacro *) (lng->macroColl[i]);
		if (expChar && (expChar != mm->immChar)) continue;
		if (!frommenu && !expChar && mm->immChar) continue;
		if (frommenu && mm->Name[0] && (lstrcmp (mm->Name, before) == 0)) return (mm);
	}

	for (i = 0; i < lng->macroColl.getCount (); i++)
	{
		TMacro	*mm = (TMacro *) (lng->macroColl[i]);
		if (expChar && (expChar != mm->immChar)) continue;
		if (mm->Word[0] && strMatch (after, mm->after, "/^\\s*", regEnd, 0))
		{
			char	realBefore[MAX_REG_LEN];
			lstrcat (lstrcpy (realBefore, mm->before), mm->Word);
			if (strMatch (before, realBefore, "/^\\s*", regEnd, 0))
			{
				if (delCount)
				{
					regEnd = lng->ignoreCase ? ")$/i" : ")$/";

					int zero[16] = { 0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 11, 12, 13, 14, 15 };
					if (strMatch (before, mm->Word, "/.*(", regEnd, 16, bounds, zero))
						*delCount = bounds[1][1] - bounds[1][0];
					else
						*delCount = 0;
				}

				return (mm);
			}
		}
	}

	return (NULL);
}

static TMacro *FindMacroKey (TLang *lng, const INPUT_RECORD *Rec)
{
	int rKey = FSF.FarInputRecordToKey (Rec);
	for (unsigned i = 0; i < lng->macroColl.getCount (); i++)
	{
		TMacro	*mm = (TMacro *) (lng->macroColl[i]);
		if (mm->FARKey == rKey) return (mm);
	}

	return (NULL);
}

static TMacro *CheckMacroPos (TLang *lng, TMacro *mm, char *before, char *after)
{
	char	*regEnd = lng->ignoreCase ? "\\s*$/i" : "\\s*$/";
	if (strMatch (after, mm->after, "/^\\s*", regEnd, 0))
		if (strMatch (before, mm->before, "/^\\s*", regEnd, 0)) return (mm);
	return (NULL);
}
