static inline char *StrLower (char *str)
{
	FSF.LStrlwr (str);
	return (str);
}

static int strMatch
(
	char	*s,
	char	*pattern,
	char	*prefix,
	char	*suffix,
	int		nb,
	int		bounds[][2] = NULL,
	int		regn[] = NULL
)
{
	int		ret = false;
	int		l = lstrlen (prefix) + lstrlen (pattern) + lstrlen (suffix);
	char	*slashPattern = (char *) malloc (l + 1);

	if (slashPattern)
	{
		static CRegExp	reg;
		SMatches				m;

		lstrcat (lstrcat (lstrcpy (slashPattern, prefix), pattern), suffix);

		if (reg.SetExpr (slashPattern))
		{
			reg.SetNoMoves (slashPattern[1] == '^' ? true : false);
			ret = reg.Parse (s, &m) ? true : false;
			if (ret)
			{
				if (bounds && regn)
					for (int i = 0; i < nb; i++)
					{
						bounds[i][0] = m.s[regn[i]];
						bounds[i][1] = m.e[regn[i]];
					}
			}
		}

		free (slashPattern);
	}

	return (ret);
}

bool lstrcmpi2 (char *szStr1, char *szStr2)
{
	for (int i = 0; i < lstrlen (szStr2); i++)
	{
		if (!szStr1[i] || ((szStr1[i] ^ szStr2[i]) & 0xDF)) return (i + 1);
	}

	return (0);
}

static inline int isCharSpace (char c)
{
	return (lstrchr (" \t\r\n", c) != NULL);
}

static char *skipSpaces (char * &line)
{
	while (*line && isCharSpace (*line)) line++;
	return (line);
}

static char *getWord (char * &line, char *kwd)
{
	char	*k = kwd;
	if (*skipSpaces (line) == '\"')
	{
		while (*++line)
		{
			if (*line == '\\' && line[1] == '\"')
				*k++ = *++line;
			else if (*line == '\"')
			{
				if (*skipSpaces (++line) != '\"') break;
			}
			else
				*k++ = *line;
		}

		*k = 0;
	}
	else
	{
		while (*line && !isCharSpace (*line)) *k++ = *line++;
		*k = 0;
	}

	return (kwd);
}

char *makeSubstr (int n, const char *origStr, int bounds[][2], int nBounds)
{
	char	*s = NULL;

	if (origStr && bounds && n < nBounds)
	{
		int len = bounds[n][1] - bounds[n][0] + 1;
		s = (char *) malloc (len + 1);
		if (s)
		{
			lstrcpyn (s, origStr + bounds[n][0], len + 1);
			s[len] = 0;
		}

		SysLog ("n=%d [%d:%d] '%s' -> '%s'\n", n, bounds[n][0], bounds[n][1], origStr, s);
	}

	return (s);
}

static char *FirstNonSpace (const char *s)
{
	char	*i = (char *) s;
	while (*i)
	{
		if (!isCharSpace (*i)) return (i);
		i++;
	}

	return (NULL);
}
